/* _______              __
  / ___/ /  ___  __ _  / /  ___
 / /__/ _ \/ _ \/  ' \/ _ \/ _ \
 \___/_//_/\___/_/_/_/_.__/\___/ 
*/

// AMRNavierStokesTimers.cpp

//
// This software is copyright (C) by the Lawrence Berkeley
// National Laboratory.  Permission is granted to reproduce
// this software for non-commercial purposes provided that
// this notice is left intact.
// 
// It is acknowledged that the U.S. Government has rights to
// this software under Contract DE-AC03-765F00098 between
// the U.S.  Department of Energy and the University of
// California.
//
// This software is provided as a professional and academic
// contribution for joint exchange. Thus it is experimental,
// is provided ``as is'', with no warranties of any kind
// whatsoever, no support, no promise of updates, or printed
// documentation. By using this software, you acknowledge
// that the Lawrence Berkeley National Laboratory and
// Regents of the University of California shall have no
// liability with respect to the infringement of other
// copyrights by any part of this software.
//


/*****************/
/*****************/

#include "AMRNavierStokesHeaders.H"

extern Timer NST_Everything;

Timer TimeNSadvance                 ("advance");
Timer TimeNSadvanceIntro            ("Intro",            TimeNSadvance);
Timer TimeNSadvanceCompAV           ("CompAV",           TimeNSadvance);
Timer TimeNSadvanceAdvectLambda     ("AdvectLambda",     TimeNSadvance);
Timer TimeNSadvanceAdvectDiffScalar ("AdvectDiffScalar", TimeNSadvance);
Timer TimeNSadvancePredictVelocities("Predict Velocity", TimeNSadvance);
Timer TimeNSadvanceCompUStar        ("Comp UStar",       TimeNSadvance);
Timer TimeNSadvanceLevelProject     ("LevelProject",     TimeNSadvance);

Timer cs0("cs0", TimeNSadvanceCompUStar);
Timer cs1("cs1", TimeNSadvanceCompUStar);
Timer cs2("cs2", TimeNSadvanceCompUStar);
Timer cs3("cs3", TimeNSadvanceCompUStar);
Timer cs4("cs4", TimeNSadvanceCompUStar);
Timer cs5("cs5", TimeNSadvanceCompUStar);
Timer cs7("cs7", TimeNSadvanceCompUStar);
Timer cs8("cs8", TimeNSadvanceCompUStar);
Timer TimeNScompUStarlevelSolve1("levelSolve1", TimeNSadvanceCompUStar);
Timer cs10("cs10", TimeNSadvanceCompUStar);
Timer cs11("cs11", TimeNSadvanceCompUStar);
Timer TimeNScompUStarlevelSolve2("levelSolve2", TimeNSadvanceCompUStar);
Timer cs13("cs13", TimeNSadvanceCompUStar);
Timer cs14("cs14", TimeNSadvanceCompUStar);
Timer cs15("cs15", TimeNSadvanceCompUStar);

Timer TimeNSpost              ("PostTimeStep");
Timer TimeNSpostPart1         ("Part1",          TimeNSpost);
Timer TimeNSpostPart2         ("Part2",          TimeNSpost);
Timer TimeNSpostImplicitReflux("ImplicitReflux", TimeNSpost);
Timer TimeNSpostSyncOperations("SyncOperations", TimeNSpost);
Timer TimeNSpostDiagnostic    ("Diagnostic",     TimeNSpost);
Timer TimeNSpostCreateBC      ("CreateBC",       TimeNSpost);

Timer TimeNSpostRegrid("PostRegrid");
Timer TimeinitialVelocityProject  ("initVelProject",     TimeNSpostRegrid);
Timer TimedoPostRegridOps         ("postRegridOps",      TimeNSpostRegrid);
Timer TimeinitializeGlobalPressure("initGlobalPress",    TimeNSpostRegrid);

Timer TimecomputeAdvectionVelocities("comp Adv Vel");
//Timer TimeSetPBC                    ("Set PBC",      TimecomputeAdvectionVelocities);
Timer TimeTraceState                ("Trace State",   TimecomputeAdvectionVelocities);
Timer TimelevelMacProject           ("levelMacProj", TimecomputeAdvectionVelocities);

Timer TimeSA_diffusionSolver      ("SA diffusion",   NST_Everything, DIAG_TABLE1);
Timer TimeSA_viscousSolver        ("SA viscous",     NST_Everything, DIAG_TABLE1);
Timer TimeSA_initialData          ("SA initData",    NST_Everything, DIAG_TABLE1);
Timer TimeSA_velocity             ("SA velocity",    NST_Everything, DIAG_TABLE1);
Timer TimeSA_scalar               ("SA scalar",      NST_Everything, DIAG_TABLE1);

Timer TimeLS_advectScalar1        ("LS advScalar1",  NST_Everything, DIAG_TABLE2);
Timer TimeLS_advectScalar2        ("LS advScalar2",  NST_Everything, DIAG_TABLE2);
Timer TimeLS_compUstar1           ("LS compUstar1",  NST_Everything, DIAG_TABLE2);
Timer TimeLS_compUstar2           ("LS compUstar2",  NST_Everything, DIAG_TABLE2);
Timer TimeLS_compUstarInit1       ("LS compUstarI1",  NST_Everything, DIAG_TABLE2);
Timer TimeLS_compUstarInit2       ("LS compUstarI2",  NST_Everything, DIAG_TABLE2);

// AMRNavierStokeInit.cpp
Timer TF_INITVORT    ("INITVORT",          NST_Everything, DIAG_TABLE4);
Timer TF_COMPUTEVORT ("COMPUTEVORT",       NST_Everything, DIAG_TABLE4);
Timer TF_INITSCAL    ("INITSCAL",          NST_Everything, DIAG_TABLE4);

// AMRNavierStokeVel.cpp
Timer TF_OPERATORLAP_ustar      ("ustar OLAP",  NST_Everything, DIAG_TABLE4);
Timer TF_OPERATORLAP_ustarInit  ("ustarI OLAP", NST_Everything, DIAG_TABLE4); //noel
Timer TF_UDELS_predictVelocities("UDELS pV",    NST_Everything, DIAG_TABLE4);

// AMRNavierStokeScal.cpp
Timer TF_OPERATORLAP_advectDiffuseScalar("advect OLAP", NST_Everything, DIAG_TABLE4);


