#ifndef _GodunovTraceF_F_H_
#define _GodunovTraceF_F_H_

#include "FORT_PROTO.H"
#include "REAL.H"

extern "C"
{

// Prototype for Fortran procedure UPWINDCELLTOEDGE ...
//
#define FORT_UPWINDCELLTOEDGE FORTRAN_NAME( UPWINDCELLTOEDGE ,upwindcelltoedge )
void 
FORT_UPWINDCELLTOEDGE(
      CHFp_FRA1(edgeState)
      ,CHFp_CONST_FRA1(cellState)
      ,CHFp_CONST_FRA(edgeVel)
      ,CHFp_BOX(edgeBox)
      ,CHFp_CONST_INT(dir) );

// Prototype for Fortran procedure SLOPES ...
//
#define FORT_SLOPES FORTRAN_NAME( SLOPES ,slopes )
void 
FORT_SLOPES(
      CHFp_FRA1(delS)
      ,CHFp_CONST_FRA1(s)
      ,CHFp_BOX(gridBox)
      ,CHFp_CONST_INT(dir)
      ,CHFp_CONST_INT(doLimit) );

// Prototype for Fortran procedure TRANSVERSE ...
//
#define FORT_TRANSVERSE FORTRAN_NAME( TRANSVERSE ,transverse )
void 
FORT_TRANSVERSE(
      CHFp_FRA1(sHat)
      ,CHFp_CONST_FRA1(s)
      ,CHFp_CONST_FRA1(vel)
      ,CHFp_BOX(gridBox)
      ,CHFp_CONST_REAL(dt)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(dir)
      ,CHFp_FRA1(dUpS) );

// Prototype for Fortran procedure TRANSVERSECROSS ...
//
#define FORT_TRANSVERSECROSS FORTRAN_NAME( TRANSVERSECROSS ,transversecross )
void 
FORT_TRANSVERSECROSS(
      CHFp_FRA1(sHat)
      ,CHFp_CONST_FRA1(s)
      ,CHFp_CONST_FRA(vel)
      ,CHFp_BOX(gridBox)
      ,CHFp_CONST_REAL(dt)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(dir) );

// Prototype for Fortran procedure PREDICT ...
//
#define FORT_PREDICT FORTRAN_NAME( PREDICT ,predict )
void 
FORT_PREDICT(
      CHFp_FRA1(sHalf)
      ,CHFp_CONST_FRA1(sHat)
      ,CHFp_CONST_FRA1(delS)
      ,CHFp_CONST_FRA1(vel)
      ,CHFp_CONST_FRA1(advVel)
      ,CHFp_BOX(edgeBox)
      ,CHFp_CONST_REAL(dt)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(dir) );

}
#endif
