/* _______              __
  / ___/ /  ___  __ _  / /  ___
 / /__/ _ \/ _ \/  ' \/ _ \/ _ \
 \___/_//_/\___/_/_/_/_.__/\___/ 
*/

// Mask.H

//
// This software is copyright (C) by the Lawrence Berkeley
// National Laboratory.  Permission is granted to reproduce
// this software for non-commercial purposes provided that
// this notice is left intact.
// 
// It is acknowledged that the U.S. Government has rights to
// this software under Contract DE-AC03-765F00098 between
// the U.S.  Department of Energy and the University of
// California.
//
// This software is provided as a professional and academic
// contribution for joint exchange. Thus it is experimental,
// is provided ``as is'', with no warranties of any kind
// whatsoever, no support, no promise of updates, or printed
// documentation. By using this software, you acknowledge
// that the Lawrence Berkeley National Laboratory and
// Regents of the University of California shall have no
// liability with respect to the infringement of other
// copyrights by any part of this software.
//
// Dan Martin, Fri, Jan 14, 2000

#ifndef _Mask_H_
#define _Mask_H_

#include "BaseFab.H"
#include "BoxLayout.H"
#include "LevelData.H"
#include "ProblemDomain.H"

// class to determine coarse-fine validity info
class Mask
{
  
public:
  enum cellType {maskCovered = -2, maskPhysical = -1, maskCopy = 0,
		 maskCoarse = 1};


  void buildMask(BaseFab<int>& a_mask, 
                 const ProblemDomain& a_dProblem, 
		 const BoxLayout& a_grids, 
		 const BoxLayout* a_fineGridsPtr=NULL, 
		 int a_nRefFine = -1);

  void buildMasks(LevelData<BaseFab <int> >& a_masks, 
		  const ProblemDomain& a_dProblem,
		  const BoxLayout& a_grids, 
		  const BoxLayout* a_fineGridsPtr=NULL, 
		  int a_nRefFine = -1);

  // deprecated interface
  void buildMask(BaseFab<int>& a_mask, const Box& a_dProblem, 
		 const BoxLayout& a_grids, 
		 const BoxLayout* a_fineGridsPtr=NULL, 
		 int a_nRefFine = -1);

  // deprecated interface
  void buildMasks(LevelData<BaseFab <int> >& a_masks, 
		  const Box& a_dProblem,
		  const BoxLayout& a_grids, 
		  const BoxLayout* a_fineGridsPtr=NULL, 
		  int a_nRefFine = -1);

};





#endif


