/* _______              __
  / ___/ /  ___  __ _  / /  ___
 / /__/ _ \/ _ \/  ' \/ _ \/ _ \
 \___/_//_/\___/_/_/_/_.__/\___/ 
*/

// computeSum.H

//
// This software is copyright (C) by the Lawrence Berkeley
// National Laboratory.  Permission is granted to reproduce
// this software for non-commercial purposes provided that
// this notice is left intact.
// 
// It is acknowledged that the U.S. Government has rights to
// this software under Contract DE-AC03-765F00098 between
// the U.S.  Department of Energy and the University of
// California.
//
// This software is provided as a professional and academic
// contribution for joint exchange. Thus it is experimental,
// is provided ``as is'', with no warranties of any kind
// whatsoever, no support, no promise of updates, or printed
// documentation. By using this software, you acknowledge
// that the Lawrence Berkeley National Laboratory and
// Regents of the University of California shall have no
// liability with respect to the infringement of other
// copyrights by any part of this software.
//
// Dan Martin, Fri, Jan 14, 2000

#ifndef _computeSum_H_
#define _computeSum_H_

#include "REAL.H"
#include "Vector.H"
#include "LevelData.H"
#include "FArrayBox.H"
#include "Interval.H"

/// Returns the volume-weighted sum (integral) of phi over all valid regions
Real computeSum(const Vector<LevelData<FArrayBox>* >& a_phi, 
		const Vector<int>& a_nRefFine,
		const Real a_dxCrse, 
		const Interval a_comps = Interval(0,0), 
		const int lBase = 0);

/// Returns the volume-weighted sum (integral) of phi over the valid region
Real computeSum(const LevelData<FArrayBox>& a_phi, 
		const DisjointBoxLayout* a_finerGrids,
		const int a_nRefFine, const Real a_dx, 
		const Interval a_comps = Interval(0,0));




#endif


